<template>
  <lightning-card  variant="Narrow"  title={accountName} icon-name="standard:account"></lightning-card>

  <template if:true={activityData}>
    <div class="c-container">
      <div class="slds-m-top_medium slds-m-bottom_x-large">
        <h2 class="slds-text-heading_medium slds-m-bottom_medium">{activityData.loc.locationNumber}</h2>  
        <h3>{activityData.loc.locationName}</h3>
        <h3>
          <lightning-formatted-address
            street={activityData.loc.locationAddress1}
            city={activityData.loc.city}
            province={activityData.loc.province}
            postal-code={activityData.loc.postalCode} ></lightning-formatted-address>
        </h3>
      </div>    
    </div>

    <lightning-progress-indicator current-step={currentStep} type="path" variant="base">
      <lightning-progress-step label="Assigned" value="s0" ></lightning-progress-step>
      <lightning-progress-step label={inProgressLbl} value="s1" ></lightning-progress-step>
      <lightning-progress-step label={pendingPartsLbl} value="s2" ></lightning-progress-step>
      <lightning-progress-step label={pendingApprovalLbl} value="s3" ></lightning-progress-step>
      <lightning-progress-step label={closedLbl} value="s4" ></lightning-progress-step>
    </lightning-progress-indicator>

    <br/>

    <template if:true={activityData.tkt.isPrimaryTechnician}>
      <lightning-button-group>
        <lightning-button label={inProgressLbl} disabled={inProgressDisabled} onclick={startWork} icon-name="utility:graph" variant="brand" class="slds-m-right_x-medium"></lightning-button>
        <lightning-button label={pendingPartsLbl}  disabled={pendingPartsDisabled} onclick={pendingParts} icon-name="utility:anchor" variant="brand" class="slds-m-left_x-small"></lightning-button>
        <lightning-button label={pendingApprovalLbl} disabled={pendingApprovalDisabled} onclick={pendingApproval} icon-name="utility:frozen" variant="brand" class="slds-m-left_x-small"></lightning-button>
        <lightning-button label={closedLbl} disabled={closedDisabled} onclick={workCompleted} icon-name="utility:like" variant="destructive" class="slds-m-left_x-small"></lightning-button>
      </lightning-button-group>
    </template>

    <br/>
    <lightning-record-view-form 
        record-id={activityData.Id}
        object-api-name="RaM_Case_Assignment__c" >
  
      <lightning-messages></lightning-messages>

      <lightning-card variant="Narrow"  title="Ticket Information" icon-name="standard:task">
        <lightning-layout-item size="12">
          <lightning-layout vertical-align="stretch" multiple-rows="true" class="x-large">
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location #</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.locationNumber}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Ticket Number (R&M)</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.tkt.ticketNumber}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Name</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.locationName}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Status</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.tkt.status}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item>
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Summary</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.tkt.subject}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Status</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;"></lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Description</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.tkt.description}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Priority</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.tkt.priority}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Type</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.equip.type}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Class</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.equip.quipClass}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item>                
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Tag</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.equip.tag}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Name</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.equip.name}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
          </lightning-layout>
        </lightning-layout-item>
      </lightning-card>

      <br/>
      <lightning-card variant="Narrow"  title="Site/Location Details" icon-name="standard:instore_locations">
        <lightning-layout-item size="12">
          <lightning-layout vertical-align="stretch" multiple-rows="true" class="x-large">
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Name</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{accountName}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Retailer</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.contact.contactName}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Email</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                  <lightning-formatted-email value={activityData.contact.contactEmail}></lightning-formatted-email>
                </lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">District Manager</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.districtManager}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item>  
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Phone</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                  <lightning-formatted-phone value={activityData.contact.contactPhone} ></lightning-formatted-phone>
                </lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Type</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.type}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item> 
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Maintenance Tech User</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.techUser}</lightning-layout-item>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Classification</lightning-layout-item>
                <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{activityData.loc.classification}</lightning-layout-item>                    
              </lightning-layout>
            </lightning-layout-item>  
            <lightning-layout-item size="12">
              <lightning-layout>
                <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Physical Address</lightning-layout-item>
                <lightning-layout-item size="10" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                  <lightning-formatted-address
                      street={activityData.loc.locationAddress1}
                      city={activityData.loc.city}
                      province={activityData.loc.province}
                      postal-code={activityData.loc.postalCode} ></lightning-formatted-address>
                </lightning-layout-item>
              </lightning-layout>
            </lightning-layout-item> 

          </lightning-layout>
        </lightning-layout-item>
      </lightning-card>
    </lightning-record-view-form>    

    <br/>
    <lightning-card variant="Narrow"  title="Upload Files" icon-name="action:upload">
      <lightning-file-upload
        label="Attach File(s)"
        name="fileUploader"
        accept={acceptedFormats}
        record-id={activityId}
        onuploadfinished={handleUploadFinished}
        multiple
      ></lightning-file-upload>
    </lightning-card>
        
  </template>

  <!--Status update comments modal-->
  <template if:true={showCommentsModal}>
    <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
  
      <div class="slds-modal__container">
        <header class="slds-modal__header">
          <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeCommentsModal}>
            <lightning-icon icon-name="utility:close" size="medium">
            </lightning-icon>
            <span class="slds-assistive-text">Close</span>
          </button>
          <h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">Add Comments</h2>
        </header> 
        
        <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">
          <lightning-textarea
              name="comments"
              value={comments}
              label="Comments"
              onchange={handleCommentsChange}
              placeholder="Type your comments here">
          </lightning-textarea>
          <footer>
            <lightning-button label="Cancel" variant="neutral" onclick={closeCommentsModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
            <lightning-button label={commentsModalLbl} disabled={isCommentsModalLblDisabled} onclick={submitComments} variant="brand" type="submit"></lightning-button>
          </footer>           
        </div>
      </div>
    </section>
    <div class="slds-backdrop slds-backdrop_open"></div>
  </template>


</template>